package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolCollegeBo;
import org.dromara.art.domain.vo.ArtSchoolCollegeVo;
import org.dromara.art.domain.ArtSchoolCollege;
import org.dromara.art.mapper.ArtSchoolCollegeMapper;
import org.dromara.art.service.IArtSchoolCollegeService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 学校学院Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolCollegeServiceImpl implements IArtSchoolCollegeService {

    private final ArtSchoolCollegeMapper baseMapper;

    /**
     * 查询学校学院
     *
     * @param collegeId 主键
     * @return 学校学院
     */
    @Override
    public ArtSchoolCollegeVo queryById(Long collegeId){
        return baseMapper.selectVoById(collegeId);
    }

    /**
     * 分页查询学校学院列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 学校学院分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolCollegeVo> queryPageList(ArtSchoolCollegeBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolCollege> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolCollegeVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的学校学院列表
     *
     * @param bo 查询条件
     * @return 学校学院列表
     */
    @Override
    public List<ArtSchoolCollegeVo> queryList(ArtSchoolCollegeBo bo) {
        LambdaQueryWrapper<ArtSchoolCollege> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolCollege> buildQueryWrapper(ArtSchoolCollegeBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolCollege> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolCollege::getCollegeId);
        lqw.eq(bo.getSchoolId() != null, ArtSchoolCollege::getSchoolId, bo.getSchoolId());
        lqw.eq(StringUtils.isNotBlank(bo.getCollegeCode()), ArtSchoolCollege::getCollegeCode, bo.getCollegeCode());
        lqw.like(StringUtils.isNotBlank(bo.getCollegeName()), ArtSchoolCollege::getCollegeName, bo.getCollegeName());
        lqw.eq(StringUtils.isNotBlank(bo.getIntroduction()), ArtSchoolCollege::getIntroduction, bo.getIntroduction());
        lqw.eq(bo.getSortNo() != null, ArtSchoolCollege::getSortNo, bo.getSortNo());
        return lqw;
    }

    /**
     * 新增学校学院
     *
     * @param bo 学校学院
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolCollegeBo bo) {
        ArtSchoolCollege add = MapstructUtils.convert(bo, ArtSchoolCollege.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setCollegeId(add.getCollegeId());
        }
        return flag;
    }

    /**
     * 修改学校学院
     *
     * @param bo 学校学院
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolCollegeBo bo) {
        ArtSchoolCollege update = MapstructUtils.convert(bo, ArtSchoolCollege.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolCollege entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除学校学院信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
